<?php
// niByLog.Kalendarz plugin 1.4.0 (c) MiMaS 2002-2003


/***config*start*****************************/
// mozna zmieniac ustawienia od tej linii az do ***config*end***

$wstawic_szablony   = 0;      // czy wlaczac szablony naglowka i stopki bloga? 1 = tak

$liczba_miesiecy    = 12;     // liczba miesiecy na kalendarzu; -1 = wszystkie
$liczba_kolumn      =  2;     // liczba kolumn z miesiacami w kalendarzu
$pokaz_tydzien      =  1;     // 0 = nie, 1 = tak
$kolejnosc_miesiecy = -1;     // 0 = od najstarszego, 1 = od najnowszego, -1 = wg ustawien niByLoga

// sciezka do strony bloga
$blog_url = $niByLog_dir.$config["cfg_blog_url"];

// czasami przy bardziej skomplikowanej strukturze URLi na blogu konieczna jest
// inna wartosc; podany tu adres powinien umozliwiac obsluzenie parametrow 
// niByLoga - ?dzien=..., ?tydzien=..., i ?miesiac=...
// np.  $blog_url = '/blog/index.php';

// grubosc linii tabeli
$table_border  = 1;

// przykladowe style inline dla schematu szarawego
$styl_td_ramka     = 'style="background: #aaa;"';
$styl_td_header    = 'style="background-color: #ccc; font-family: Verdana, Arial; font-size: 8pt; border: 1px solid #aaa;"';
$styl_td_subheader = 'style="background-color: #ddd; font-family: Verdana, Arial; font-size: 8pt; font-weight: normal;"';
$styl_td_normal    = 'style="background-color: #eee; font-family: Verdana, Arial; font-size: 8pt;"';
$styl_div_info     = 'style="color: #aaa; font-family: Verdana, Arial; font-size: 8pt;"';
$styl_a            = 'style="color: #66e; font-family: Verdana, Arial; font-size: 8pt; text-decoration: none; border-bottom: 0px;"';
$styl_h            = 'style="font-family: Verdana, Arial; font-size: 10pt;"';

// style moga tez byc okreslone przez klasy, ktore naley zdefiniowac w css strony bloga
/* np.
$styl_td_ramka     = 'class="kalendramka"';
$styl_td_header    = 'class="kalendheader"';
$styl_td_subheader = 'class="kalendsubheader"';
$styl_td_normal    = 'class="kalendnormal"';
$styl_div_info     = 'class="kalendinfo"';
$styl_a            = 'class="kalenda"';
$styl_h            = 'class="kalendh"';
*/

// przykladowe style inline dla schematu brazowo-zielonego
/*
$styl_td_ramka     = 'style="background: #807050;"';
$styl_td_header    = 'style="background-color: #bfaf90; font-family: Verdana, Arial; font-size: 8pt; border: 1px solid #807050;"';
$styl_td_subheader = 'style="background-color: #e5dcc5; font-family: Verdana, Arial; font-size: 8pt; font-weight: normal;"';
$styl_td_normal    = 'style="background-color: #f7efd7; font-family: Verdana, Arial; font-size: 8pt;"';
$styl_div_info     = 'style="color: #807050; font-family: Verdana, Arial; font-size: 8pt;"';
$styl_a            = 'style="font-family: Verdana, Arial; font-size: 8pt; text-decoration: none; font-weight: bold;"';
$styl_h            = 'style="font-family: Verdana, Arial; font-size: 10pt;"';
*/

/***config*end*****************************/

/***the*story*so*far***********************

1.4.0 (2003-09-17)
[*] dodane elementy ulatwiajace uzycie tabel w przegladarkach niegraficznych - tagi <caption> i <th> oraz atrybuty summary
[+] zmienna $wstawic_szablony - wartosc 1 oznacza, ze beda wlaczane szablony blog_head i blog_foot

1.3.0 (2003-04-05)
[+] nowa zmienna $blog_url
[*] zmiana znaczenia zmiennych $styl_... - moga zawierac "style =" lub "class =" lub "id =" jak wolisz

1.2.0 (2002-09-30)
[*] zmiana HTML na XHTML

1.1.3 (2002-06-03)
[+] mozliwosc ustalenia grubosci linii generowanych tabel

1.1.2 (2001-10-08)
[+] mozliwosc ustalenia liczby pokazywanych kolumn z miesiacami - zmienna $liczba_kolumn
[+] $liczba_miesiecy < 0 oznacza wszystkie miesiace
[+] dodatkowa kolumna z numerem tygodnia i linkiem do wpisow z danego tygodnia; wyswietlanie zalezne od ustawienia parametru $pokaz_tydzien
[+] mozliwosc ustalenia kolejnosci miesiecy: $kolejnosc_miesiecy = 0 -> od najstarszego, = 1 -> od najnowszego, = -1 -> zgodna z kolejnoscia sortowania wpisow archiwalnych ustawiona w konfiguracji niByLoga
[*] wszystkie miesiace w kalendarzu skladaja sie z 6 tygodni nawet jesli ostatni tydzien wychodzi pusty; dzieki temu kazdy miesiac zajmuje dokladnie taki sam prostokat
[*] dni tygodnia liczone od poniedzialku a nie od niedzieli
[*] wszystkie linki do wpisow zawieraja jawnie nazwe pliku plugina - poprawia to dzialanie linkow w dziwnych przegladarkach

1.0.1 (2001-09-28)
[!] premiera

******************************************/

// about:plugin

$plugin_nazwa = "kalendarz";
$plugin_numer = "1.4.0";
$plugin_autor = "MiMaS";
$plugin_email = "plugins@mimas.ceti.pl";
$plugin_www = "http://mimas.ceti.pl/plugins/";
$plugin_opis = "Plugin umoliwiajcy prezentacj archiwum niByLoga w postaci kalendarza z zaznaczonymi dniami, w ktrych byy wpisy.";


set_time_limit(0);
$start_time = time();

if ( $wstawic_szablony )
  WstawSzablon('blog_head'); 
?>
<!-- niByLog.Kalendarz plugin -->
<div id="kalendarz">
<div align="center">

<h1 <?php echo( $styl_h ); ?>>kalendarz wpisw</h1>
<div <?php print $styl_div_info; ?> align="center"><a <?php print $styl_div_info; ?> href="http://mimas.ceti.pl/plugins/" target="_blank">niByLog.Kalendarz plugin <?php print $plugin_numer; ?> &copy; MiMaS</a></div>
<br />

<table border="0" cellspacing="1" cellpadding="0" summary="">
<tr>
<?php

function DzienTygodnia( $timestamp )
{
  $dt = date("w", $timestamp);
  if ( $dt == 0 ) $dt = 6;
  else $dt--;
  return $dt;
}

$miesiac = array( "","stycze","luty","marzec","kwiecie","maj","czerwiec","lipiec","sierpie","wrzesie","padziernik","listopad","grudzie" );
$dow = array( "Pn","Wt","r","Cz","Pt","So","Nd" );
$fdow = array( "Poniedziaek","Wtorek","roda","Czwartek","Pitek","Sobota","Niedziela", "Tydzie" );

$blog = CzytajWpisy("ADMIN","nibylog");
$blog_count = count($blog);
if ( $blog[$blog_count] == "" ) $blog_count--;

if ( $kolejnosc_miesiecy < 0 )
  $kolejnosc_miesiecy = $config["cfg_archiwum_sort"];
if ( $kolejnosc_miesiecy == 1 )
  rsort($blog, SORT_NUMERIC);
else
  sort($blog, SORT_NUMERIC);

$miech = 0;
for ( $i = 0; $i <= $blog_count; $i++ )
{
  $wpis = split( "\t", $blog[$i] );

  if ( $m != date("Y/m",$wpis[0]) )
  {
    $m = date("Y/m",$wpis[0]);
    $miech++;
    if ( ($liczba_miesiecy > 0) && ($miech > $liczba_miesiecy) ) 
    {
      $miech--;
      break;
    }
    
    $mm = date("m",$wpis[0]);
    $yy = date("Y",$wpis[0]);

    $dni_z_wpisami = array("0"=>0);
    $d = $i;
    while ( date("Y/m",$blog[$d]) == $m )
    {
      $dni_z_wpisami[date("d",$blog[$d])]++;
      $d++;
    }

    echo( '<td '.$styl_td_ramka.'><table border="0" cellspacing="'.$table_border.'" cellpadding="1" width="100%" summary="Kalendarz za '.$miesiac[intval($mm)].' '.$yy.' z linkami do wpisw z poszczeglnych dni">'."\n" );
  
    echo( '<caption '.$styl_td_header.'>' );
    echo( '<a '.$styl_a.' href="'.$blog_url.'?miesiac='.$m.'">'.$miesiac[intval($mm)].' '.$yy.'</a>' );
    echo( "</caption>\n<tr>" );
    if ( $pokaz_tydzien ) 
      echo( '<th '.$styl_td_subheader.' align="center" abbr="'.$fdow[7].'">&nbsp;T&nbsp;</th>' );
    for ( $d = 0; $d < 7; $d++ )
      echo( '<th '.$styl_td_subheader.' abbr="'.$fdow[$d].'">&nbsp;'.$dow[$d].'&nbsp;</th>' );
    echo( "</tr>\n<tr>" );

    
    if ( $pokaz_tydzien )
    {
      $tt = Tydzien(mktime(0,0,1,$mm,1,$yy));
      echo( '<td '.$styl_td_subheader.'>&nbsp;<a '.$styl_a.' href="'.$blog_url.'?tydzien='.$yy.'/'.$tt.'">'.$tt.'</a>&nbsp;</td>' );
    }

    $startwd = DzienTygodnia(mktime(0,0,1,$mm,1,$yy));
    for ( $d = 0; $d < $startwd; $d++ )
      echo( '<td '.$styl_td_normal.'>&nbsp;</td>' );

    $maxd = date("t",$wpis[0]);
    $d = 1;
    $k = 0;
    $w = 0;
    while ( $d <= $maxd )
    {
      echo( '<td '.$styl_td_normal.' align="right">&nbsp;' );
      if ( in_array($d,array_keys($dni_z_wpisami)) )
        echo( '<a '.$styl_a.' href="'.$blog_url.'?dzien='.sprintf("%4d/%02d/%02d",$yy,$mm,$d).'">'.$d.'</a>' );
      else
        echo( $d );
      echo( '&nbsp;</td>' );

      $k = (($d + $startwd) % 7);
      if ( $k == 0 )
      {
        echo( "</tr>\n<tr>" );
        if ( $pokaz_tydzien )
        {
          $tt = Tydzien(mktime(0,0,1,$mm,$d+1,$yy));
          echo( '<td '.$styl_td_subheader.'>&nbsp;<a '.$styl_a.' href="'.$blog_url.'?tydzien='.$yy.'/'.$tt.'">'.$tt.'</a>&nbsp;</td>' );
        }
        $w++;
      }
      $d++;
    }
    for ( $d = $k; $d < 7; $d++ )
      echo( '<td '.$styl_td_normal.'>&nbsp;</td>' );
    for ( $d = $w; $d < 5; $d++ )
    {
      echo( "</tr>\n<tr>" );
      if ( $pokaz_tydzien ) echo( '<td '.$styl_td_subheader.'>&nbsp;</td>' );
      echo( '<td '.$styl_td_normal.'>&nbsp;</td><td '.$styl_td_normal.'>&nbsp;</td><td '.$styl_td_normal.'>&nbsp;</td><td '.$styl_td_normal.'>&nbsp;</td><td '.$styl_td_normal.'>&nbsp;</td><td '.$styl_td_normal.'>&nbsp;</td><td '.$styl_td_normal.'>&nbsp;</td>' );
    }
    echo( "</tr>\n</table></td>\n" );

    if ( ($miech % $liczba_kolumn) == 0 )
      echo( "</tr><tr>\n" );
  }
}
for ( $d = 0; $d < $liczba_kolumn - ($miech % $liczba_kolumn); $d++ )
  echo ( '<td></td>' );
?>
</tr>
</table>

</div>
</div>
<!-- niByLog.Kalendarz plugin -->

<?php
if ( $wstawic_szablony )
  WstawSzablon('blog_foot'); 
?>
